//=============================================================================
// FShark_RC4U1.  - A fly/devilfish mutant.  With a frickin laser. The U1 version. 2015 - Mr.Loathsome
//=============================================================================
class FS extends Fly;

#exec TEXTURE IMPORT NAME=swfl3 FILE=Textures\swfl3.pcx
#exec TEXTURE IMPORT NAME=swfl260 FILE=Textures\swfl260.pcx
#exec TEXTURE IMPORT NAME=EGShark01 FILE=Textures\EGShark01.pcx

var() byte BiteDamage;
var() int LaserDamage;
var() int LaserLength;
var() int SharkColor;
var() Texture AltTexture;

var FLBolt FrickinLaserBeam;

function PreBeginPlay()
{
	PickSkin();
	Super.PreBeginPlay();
}

simulated function Destroyed()
{
	if ( FrickinLaserBeam != None )
		FrickinLaserBeam.Destroy();
	Super.Destroyed();
}

function ZoneChange(ZoneInfo newZone)
{
}

function PickSkin()
{
	local int SkinNum;

	if (AltTexture != None)
		MultiSkins[1] = AltTexture;
	else
	{
	if (SharkColor >= 4) { SkinNum = Rand(4); } else { SkinNum = SharkColor; }
	Switch(SkinNum)
		{
		Case 3:
			MultiSkins[1] = Texture'EGShark01';
			break;
		Case 2:
			MultiSkins[1] = Texture'swfl260';
			break;
		Case 1:
			MultiSkins[1] = Texture'swfl3';
			break;
		Case 0:
			MultiSkins[1] = Texture'JFish1';
		}
	}
}

function Carcass SpawnCarcass()
{
	local carcass carc;

	carc = Spawn(CarcassType);
	if ( carc != None )
	{
		carc.Initfor(self);
		carc.MultiSkins[1] = Self.MultiSkins[1];
	}
	return carc;
}

function PlayWaiting()
{
	if ( Physics == PHYS_Walking )
		TweenAnim('breathing', 10.0);
	else
		LoopAnim('Swimming', 0.75);
}

function PlayChallenge()
{
	if ( FRand() < 0.330 )
		PlayAnim('bite1', 1.0, 0.1);
	else
	if ( FRand() < 0.330 )
		PlayAnim('bite2', 1.0, 0.1);
	else
		PlayAnim('bite3', 1.0, 0.1);
}

function TweenToFighter(float tweentime)
{
	TweenAnim('Swimming', tweentime);
}

function TweenToRunning(float tweentime)
{
	if ( (AnimSequence != 'Swimming') || !bAnimLoop )
		TweenAnim('Swimming', tweentime);
}

function TweenToWalking(float tweentime)
{
	if (Physics == PHYS_Walking)
		TweenAnim('breathing', tweentime);
	else if ( (AnimSequence != 'Swimming') || !bAnimLoop )
		TweenAnim('Swimming', tweentime);
}

function TweenToWaiting(float tweentime)
{
	PlayAnim('flopping', 0.2 + 0.5 * FRand());
	SetPhysics(PHYS_Falling);
}

function TweenToPatrolStop(float tweentime)
{
	TweenAnim('Swimming', tweentime);
}

function PlayRunning()
{
	LoopAnim('Swimming');
}

function PlayWalking()
{
	if (Physics == PHYS_Walking)
		LoopAnim('breathing', -1.0/GroundSpeed,, 0.4);
	else
		LoopAnim('Swimming');
}

function PlayThreatening()
{
	if ( FRand() < 0.8 )
		LoopAnim('Swimming');
	else
		LoopAnim('bite2', 0.4);
}

function PlayTurning()
{
	if (Physics == PHYS_Walking)
		LoopAnim('breathing');
	else
		LoopAnim('Swimming');
}

function PlayDying(name DamageType, vector HitLocation)
{
	if ( FRand() < 0.50 )
	{
		PlayAnim('breathing', 0.1 + (0.5 * FRand()),0.1250 + (4.0 * FRand()));
	}
	else
	if ( FRand() < 0.50 )
	{
		PlayAnim('flopping', 0.1 + (0.5 * FRand()),0.1250 + (4.0 * FRand()));
		
	}
	else PlayAnim('ripper', 0.1 + (0.5 * FRand()),0.1250 + (4.0 * FRand()));
	PlaySound(Die, SLOT_Talk, 2.5 * TransientSoundVolume);
}

function PlayTakeHit(float tweentime, vector HitLoc, int damage)
{
	if (FRand() < 0.330) PlayAnim('ripper', 0.8,0.1);
	else PlayAnim('TakeHit',  0.1 + (0.5 * FRand()),0.1250 + (1.0 * FRand()));
}

function TweenToFalling()
{
	TweenAnim('Swimming', 0.2);
}

function PlayInAir()
{
	LoopAnim('Swimming');
}

function PlayLanded(float impactVel)
{
	PlayAnim('flopping');
}

function PlayVictoryDance()
{
	if ( FRand() < 0.50 )
	{
		PlayAnim('flopping', 0.1 + (0.5 * FRand()),0.1250 + (4.0 * FRand()));
	}
	else
	{
		PlayAnim('ripper');
	}
	if ( FRand() < 0.4 )
		TweenToWaiting(0.25);
	else
		PlayAnim('grab1',1.0, 0.05);
}
	
function PlayMeleeAttack()
{
	if (FrickinLaserBeam != None)
		FrickinLaserBeam.Destroy();
	if ( FRand() < 0.330 )
		PlayAnim('bite1', 1.0, 0.1);
	else
	if ( FRand() < 0.330 )
		PlayAnim('bite2', 1.0, 0.1);
	else
		PlayAnim('bite3', 1.0, 0.1);
	if ( MeleeDamageTarget(BiteDamage, (BiteDamage * 1000.0 * Normal(Target.Location - Location))) )
		PlaySound(HitSound2, SLOT_Talk);
	GotoState('TacticalMove', 'BackOff');
}

function PlayRangedAttack()
{
	local Vector adjust, projStart;

	if ((bHasRangedAttack) && (FRand() < RefireRate) && (FrickinLaserBeam == None))
	{
		if ( FRand() < 0.50 )
			PlayAnim('bite3');
		else
			PlayAnim('bite2');
		adjust = vect(0,0,0);
		adjust.Z = Target.CollisionHeight - 20;
		Acceleration = AccelRate * Normal(Target.Location - Location + adjust);
		projStart = Location - 0.5 * CollisionHeight * vect(0,0,1);
		if (FrickinLaserBeam == None)
		{
			FrickinLaserBeam = FLBolt(spawn(RangedProjectile ,self,'',projStart,AdjustAim(ProjectileSpeed, projStart, 400, false, false)));
			if (FrickinLaserBeam != None)
			{
				FrickinLaserBeam.Damage = LaserDamage;
				FrickinLaserBeam.DamageRate = (100 - LaserDamage);
				FrickinLaserBeam.BeamLength = LaserLength;
				Acceleration = vect(0,0,0);
			}
		}
	}
	else
	{
		if (FrickinLaserBeam != None)
		{
			if ( FRand() < 0.250 )
				PlayAnim('bite3');
			else if ( FRand() < 0.250 )
				PlayAnim('bite2');
		}

	}
}

state RangedAttack
{
ignores SeePlayer, HearNoise, HitWall;

	function TakeDamage( int Damage, Pawn instigatedBy, Vector hitlocation, 
						Vector momentum, name damageType)
	{
		Global.TakeDamage(Damage, instigatedBy, hitlocation, momentum, damageType);
		if ( health <= 0 )
			return;
		if (NextState == 'TakeHit')
		{
			NextState = 'RangedAttack';
			NextLabel = 'Begin';
		}
	}

	function StopWaiting()
	{
		Timer();
	}

	function EnemyNotVisible()
	{
		////log("enemy not visible");
		//let attack animation completes
	}

	function KeepAttacking()
	{
		if ( !bFiringPaused && ((FRand() > ReFireRate) || (Enemy == None) || (Enemy.Health <= 0) || !CanFireAtEnemy()) ) 
			GotoState('Attacking');
	}

	function Timer()
	{
		if ( bFiringPaused )
		{
			TweenToRunning(0.12);
			GotoState(NextState, NextLabel);
		}
	}

	function AnimEnd()
	{
		GotoState('RangedAttack', 'DoneFiring');
	}
	
	function BeginState()
	{
		Target = Enemy;
		Disable('AnimEnd');
		bReadyToAttack = false;
		if ( bFiringPaused )
		{
			SetTimer(SpecialPause, false);
			SpecialPause = 0;
		}
		SetMovementPhysics();
	}
	
	function EndState()
	{
		bFiringPaused = false;
	}

Challenge:
	Disable('AnimEnd');
	Acceleration = vect(0,0,0); //stop
	if (FrickinLaserBeam != None)
	{
		FrickinLaserBeam.Destroy();
		bAltFire = 0;
	}
	PlayChallenge();
	FinishAnim();
	TweenToFighter(0.1);
	Goto('FaceTarget');

Begin:
	if ( Enemy == None )
		GotoState('Attacking');
	Acceleration = vect(0,0,0); //stop
	TweenToFighter(0.15);
	
FaceTarget:
	Disable('AnimEnd');
	if (NeedToTurn(Enemy.Location))
	{
		PlayTurning();
		TurnToward(Enemy);
		TweenToFighter(0.1);
	}
	FinishAnim();

ReadyToAttack:
	if (VSize(Location - Enemy.Location) < 0.9 * MeleeRange + CollisionRadius + Enemy.CollisionRadius)
	{
		GotoState('MeleeAttack');
	}
	if (FRand() > 0.50)
		PlayRunning();
	else
		PlayWalking();
	if (LineOfSightTo(Enemy))
	{
		PlayTurning();
		TurnToward(Enemy);
		MoveToward(Enemy);
	}
	else
	{
		PlayTurning();
		TurnTo(LastSeenPos);
		MoveTo(LastSeenPos);
	}

	PlayRangedAttack();
	Enable('AnimEnd');
Firing:
	if (Enemy == None )
		GotoState('Attacking');
	TurnToward(Enemy);

	if (VSize(Location - Enemy.Location) > 0.9 * MeleeRange + CollisionRadius + Enemy.CollisionRadius)
		Goto('Firing');
DoneFiring:
	Disable('AnimEnd');
	KeepAttacking();  
	Goto('FaceTarget');
}

state TacticalMove
{
ignores SeePlayer, HearNoise;

BackOff:
	if (Enemy == None)
		GotoState('Wandering');
	Acceleration = AccelRate * Normal(Location - Enemy.Location);
	Acceleration.Z *= 0.5;
	Destination = Location;
	Sleep(0.5);
	SetTimer(TimeBetweenAttacks, false);
	Goto('TacticalTick');
}

state Roaming
{
	function PickDestination()
	{
		GotoState('Wandering');
	}

Begin:
	if (FrickinLaserBeam != None)
	{
		FrickinLaserBeam.Destroy();
		bAltFire = 0;
	}
	GotoState('Wandering');
}

defaultproperties
{
     BiteDamage=20
     LaserDamage=30.0
     LaserLength=20
     SharkColor=0
     AltTexture=None
     CarcassType=Class'UnrealShare.DevilfishCarcass'
     MeleeRange=40.000000
     bHasRangedAttack=True
     bMovingRangedAttack=False
     RefireRate=0.50000
     RangedProjectile=Class'FShark_RC4U1.LStarterBolt'
     WaterSpeed=100.000000
     SightRadius=8100.000000
     Health=90
     CollisionRadius=35.000000
     CollisionHeight=20.000000
     HitSound1=Sound'UnrealShare.Razorfish.chomp1fs'
     HitSound2=Sound'UnrealShare.Razorfish.miss1fs'
     Land=Sound'UnrealShare.Razorfish.flop1fs'
     Die=Sound'UnrealShare.Razorfish.death1fs'
     CombatStyle=1.000000
     AmbientSound=Sound'UnrealShare.Razorfish.ambfs'
     Mesh=LodMesh'UnrealShare.fish'
     MenuName="Frickin Shark"
}
