//=============================================================================
// lstarterbolt.
//=============================================================================
class LStarterBolt extends FLBolt;

#exec MESHMAP SETTEXTURE MESHMAP=lbolt NUM=0 TEXTURE=lbolt0

var rotator AimRotation;
var float AnimTime;

simulated function Tick(float DeltaTime)
{
	local vector X,Y,Z, DrawOffset;

	// orient with respect to instigator
	if ( Instigator == None )
	{
		Self.Destroy();
	}
	else
	{
		AimRotation = Instigator.Rotation;
		if (Level.NetMode == NM_Client)
		{
			SetRotation(AimRotation); 
			DrawOffset = ((0.01 * vect(0.0, 0.0, -2.0)) >> Rotation);
			DrawOffset += (Instigator.EyeHeight * vect(0,0,1));
		}
		SetRotation(AimRotation);
		GetAxes(Instigator.Rotation,X,Y,Z);

		FireOffset.Z = Default.FireOffset.Z * 1.5;
		FireOffset.Y = 0;
		FireOffset.X = Instigator.CollisionRadius * 1.15;
		SetLocation(Instigator.Location + DrawOffset + FireOffset.X * X + FireOffset.Y * Y + FireOffset.Z * Z);


	}
	CheckBeam(X, DeltaTime);
}

defaultproperties
{
     RemoteRole=ROLE_SimulatedProxy
     AmbientGlow=187
     LightType=LT_Steady
     LightEffect=LE_NonIncidence
     LightBrightness=255
     LightHue=3
     LightSaturation=50
     LightRadius=5
}
